var textSelected;   //选中的文本
var currentEditOffset;  //当前编辑的光标坐标
var htmlold;    //文档旧的内容
//获取标签属性名
let getAttrList = target => target.attributes ? Array.from(target.attributes) : Array.from(target[0].attributes);
//文本编辑区监听
(function($) {
    $.fn.wysiwygEvt = function() {
        return this.each(function() {
            var $this = $(this);
            htmlold = $this.html();
            $this.bind('blur keyup paste copy cut mouseup', function(e) {
                let timer = setTimeout(function(){
                    let htmlnew = $this.html();
                    if (htmlold !== htmlnew) {
                        $this.trigger('change'); 
                        clearTimeout(timer); 
                    } 
                },200);
            });  
        })
    }
    $(".content").bind("change", function(e) {
        htmlold = $(this).html();
        var text = $(this).text();
        var length = fnGetCpmisWords(text);
        var size = $(this).css('font-size');
        //获取光标位置
        let offset = getDivPosition(e.target);
        let offsetText = getPositionBeforeText(e.target);
        console.log("change----解析文档");
        //parseWord1(updatePage);
        
        var dict = {
            action: 'writing',
            data: {
                'length': length,
                'wordFontSize': size,
                'offsetText' : encodeURIComponent(offsetText),
                'undo' : document.queryCommandEnabled("undo"),
                'redo' : document.queryCommandEnabled("redo")
            }
        };
        var jsonstr = JSON.stringify(dict);
        if(window.android){
            window.android.postMessage(jsonstr);
        }else if(window.webkit){
            window.webkit.messageHandlers.sendMessage.postMessage(jsonstr);
        }
    });
    //初始监听
    $(".content").change();
    setTimeout(function(){
        $(".content").focus();
    },200);
})(jQuery);

function onReady() {
    document.execCommand("styleWithCSS", 0, true);
    var dict = {
        action: 'onready',
        data: {}
    };
    var jsonstr = JSON.stringify(dict);
    if(window.android){
        window.android.postMessage(jsonstr);
    }else if(window.webkit){
        window.webkit.messageHandlers.sendMessage.postMessage(jsonstr);
    }
}

//获取文档的字数
function getHtmlLength() {
    var text = $('.content').text();
    var length = fnGetCpmisWords(text);
    var dict = { 'length': length, 'wordFontSize': 3 };
    return JSON.stringify(dict);
}

 function restoreSelection(){
    var range = selectionRange;
    if(range){
        if(window.getSelection){
            var sel = window.getSelection();
            sel.removeAllRanges();
            sel.addRange(range);

        } else if(document.selection && range.select){
            range.select();
        }
    }
}

function setCaretPosition(ctrl, pos){  
    //设置光标位置函数   
    if(ctrl.setSelectionRange) {  
    ctrl.focus();  // 获取焦点  
    ctrl.setSelectionRange(pos,pos);  // 设置选定区的开始和结束点  
    } else if (ctrl.createTextRange){   
        var range = ctrl.createTextRange();  // 创建选定区  
        range.collapse(true);                // 设置为折叠,即光标起点和结束点重叠在一起  
        range.moveEnd('character', pos);     // 移动结束点  
        range.moveStart('character', pos);   // 移动开始点  
        range.select();                      // 选定当前区域  
    }   
}  



//获取字数
function fnGetCpmisWords(str) {
    sLen = 0;
    try {
        //先将回车换行符做特殊处理
        str = str.replace(/(\r\n+|\s+|　+)/g, "");
        //处理英文字符数字，连续字母、数字、英文符号视为一个单词
        // str = str.replace(/[\x00-\xff]/g,"m");   
        //合并字符m，连续字母、数字、英文符号视为一个单词
        // str = str.replace(/m+/g,"*");
        //去掉回车换行符
        //str = str.replace(/龘+/g, "");
        //返回字数
        sLen = str.length;
    } catch (e) {

    }
    return sLen;
}

//分页
function updatePage(data) {
    var ceils = data ? data : $('.page .content').children();     //内容区所有子元素
    var page = 1;
    //对内容进行判断处理分页标志，添加分页间距
    for (var i = 0; i < ceils.length; i++) {
        // if(page == 10){
        //     break;
        // }
        var $ceil = $(ceils[i]);    //一个段落
        let $last = $(ceils[i - 1]);    //上一个
        var ceilHeight = $ceil.offset().top + $ceil.height();   //该段的顶部偏移加自身高度
        if($ceil.attr("class") && $ceil.attr("class").indexOf("page-cate-last") != -1){  //判断目录标记是最后一个，直接分页
            if($ceil.next().attr("class") && $ceil.next().attr("class").indexOf("page-cate-break") != -1){
                $ceil.next().remove();
                i++;
            }
            let cateBreak = $("<p></p>");
            cateBreak.attr("style",$ceil.attr("style"));
            $ceil.after(cateBreak);
            let contentHeight = page * pageHeight - ceilHeight - 50;
            cateBreak.addClass("page-cate-break").css({
                height : contentHeight,
                marginBottom : "100px"
            });
            page++;
            continue;
        }
        if($ceil.height()>(pageHeight - 100)){  //该段内容高是否超过一页高度
            if($ceil.find('img').length>0){   //是否子元素是图片       
                $ceil.find('img').height(pageHeight-100)
            }
            if($ceil.is('img')){    // 是否是图片 
                $ceil.height(pageHeight-100);
            }else if($ceil.is('table')){    //是否是表格
                spliteTable($ceil);     //拆分表格
                return;
            }else if($ceil.find('table').length>0) {    //是否嵌套表格
                spliteTable($ceil.find('table').eq(0)); 
                return;
            }
        }
        if (ceilHeight > (pageHeight * page - 50)) {    //该段距离超过所在页内容高度
            let lastHeight = $ceil.offset().top;   //高度为当前段顶部偏移
            let fillHeight = (pageHeight * page - 50) - lastHeight; //计算当前页剩余高度
            $ceil.css("margin-bottom", '0');    
            $ceil.removeClass("page-break"); 
            let childs = $ceil.children();
            childs.each((index,child) => {
                let $child = $(child);
                let childOffset = $child.offset().top + $child.height();
                if(childOffset > pageHeight * page - 50){
                    fillHeight = (pageHeight * page -50) - $child.offset().top;
                    $child.addClass("page-under-break");
                }
            });
            if(fillHeight >= 28){
                ceilSplitPd($ceil,fillHeight);
                $ceil.remove(); 
            }else{
                $last.height($last.height()+fillHeight);
                $last.css("margin-bottom", '100px');
            }
            page++; //页数增加
        } else {        //该段高度不超过一页时,不存在分页标志
            $ceil.css("margin-bottom", '0');
            $ceil.removeClass("page-break");
        }
    }
    updatePageSplit(page);
}

//展示分页容器
function updatePageSplit(page){
    console.log(page + "页");
    $('.page-split').empty();//初始化分页容器，对新页数，重新计算每页位置
    var pageHeight = 878;
    pageHeader = pageHeader ? pageHeader : "";
    pageFooter = pageFooter ? pageFooter : "";
    pageBackground = pageBackground ? pageBackground : "";
    for (var i = 0; i < page; i++) {
        //创建每页页眉、页脚,计算距分页容器顶部偏移量、默认插入空背景图片占位（无图片默认隐藏）,最后添加至分页容器
        var $header = $('<header class="p1"><div class="left"></div><p class="h-content">' + pageHeader + '</p><div class="right"></div></header>')
        var $footer = $('<footer class="p1"><div class="left"></div><p class="f-content">' + pageFooter + '</p><p class="pagination">第' + (i + 1) + '页</p><div class="right"></div></footer>')
        $header.css('top', i * (pageHeight) + 'px')
        $footer.css('top', ((i + 1) * pageHeight - 50) + 'px')
        var $bg = $('<img src="' + pageBackground + '" class="background" name = "background" />');
        $bg.css('top', (i * pageHeight) + 'px')
        if (pageBackground == '') {
            $bg.hide();
        }
        $('.page-split').append($header);
        $('.page-split').append($bg);
        $('.page-split').append($footer);
    }
}

//拆分段落内容
function ceilSplit(p){
    let spans = p.children();
    let next = p.next();
    spans.each((index,span) => {
        let $span = $(span);
        let attrs = getAttrList($span);
        let newCeil = $("<p><span></span></p>");
        newCeil.attr("class",p.attr("class"));
        newCeil.attr("style",p.attr("style"));
        attrs.forEach(attr => newCeil.attr(attr.name,attr.value));
        next.before(newCeil);
        if($span.height() > (pageHeight - 100)){
            let text = $span.text();
            newCeil.addClass("ceil-split");
            for(let i = 0; i < text.length; i++){
                if(newCeil.height() < (pageHeight - 100 - 23)){
                    let str = newCeil.find("span").text() + text[i];
                    newCeil.find("span").text(str);
                }else{
                    let afterCeil = $("<p><span></span></p>");
                    afterCeil.attr("class",p.attr("class"));
                    afterCeil.attr("style",p.attr("style"));
                    afterCeil.find("span").attr("class",$span.attr("class"));
                    afterCeil.find("span").attr("style",$span.attr("style"));
                    afterCeil.addClass("ceil-split-after");
                    newCeil.after(afterCeil);
                    for(let j = i; j < text.length; j++){
                        if(afterCeil.height() < (pageHeight - 100 - 23)){
                            let str = afterCeil.find("span").text() + text[j];
                            afterCeil.find("span").text(str);
                        }else{
                            let lastCeil = afterCeil;
                            afterCeil = $("<p><span></span></p>");
                            afterCeil.attr("class",p.attr("class"));
                            afterCeil.attr("style",p.attr("style"));
                            afterCeil.find("span").attr("class",$span.attr("class"));
                            afterCeil.find("span").attr("style",$span.attr("style"));
                            afterCeil.addClass("ceil-split-after");
                            lastCeil.after(afterCeil);
                            j--;
                        }
                    }
                    break;
                }
            }        
        }else if($span.text()){
            newCeil.text($span.text());
        } 
    });
}

/**
 * //拆分超出分页的段落,将一个P标签下的所有span标签变成一个单独的段落,
 * 将其中内容超出分页的一段作为分页段落，填充内容至填满本页剩余高度，默认
 * 距下一页边距100px
 * @method  ceilSplitPd  
 * @param   { Object }  p   将要被拆分的P元素
 * @param   { Number }  fill   本页的剩余内容高度  
 *     
*/
function ceilSplitPd(p,fill){
    let spans = p.children();
    let next = p.next();
    spans.each((index,span) => {
        let $span = $(span);
        let attrs = getAttrList($span);
        let fillCeil = $("<p><span></span></p>");
        fillCeil.attr("class",p.attr("class"));
        fillCeil.attr("style",p.attr("style"));
        attrs.forEach(attr => fillCeil.find("span").attr(attr.name,attr.value));
        fillCeil.addClass("ceil-fill");
        next.before(fillCeil);
        if($span.text()){
            if($span.attr("class") && $span.attr("class").indexOf("page-under-break") != -1){
                fillCeil.attr("class","page-break");
                fillCeil.css("margin-bottom","100px");
            }
            let text = $span.text();
            let lh = 0;
            for(let i = 0; i < text.length; i++){
                if(fillCeil.height() < fill - lh){
                    let str = fillCeil.find("span").text() + text[i];
                    fillCeil.find("span").text(str);
                    if(i == 0) lh = fillCeil.height();
                }else{
                    fillCeil.height(fill);
                    let afterCeil = $("<p><span></span></p>");
                    afterCeil.attr("class",p.attr("class"));
                    afterCeil.attr("style",p.attr("style"));
                    afterCeil.find("span").attr("class",$span.attr("class"));
                    afterCeil.find("span").attr("style",$span.attr("style"));
                    afterCeil.addClass("ceil-fill-after");
                    fillCeil.after(afterCeil);
                    for(let j = i; j < text.length; j++){
                        if(afterCeil.height() < (pageHeight - 100 - 23)){
                            let str = afterCeil.find("span").text() + text[j];
                            afterCeil.find("span").text(str);
                        }else{
                            let lastCeil = afterCeil;
                            afterCeil = $("<p><span></span></p>");
                            afterCeil.attr("class",p.attr("class"));
                            afterCeil.attr("style",p.attr("style"));
                            afterCeil.find("span").attr("class",$span.attr("class"));
                            afterCeil.find("span").attr("style",$span.attr("style"));
                            afterCeil.addClass("ceil-fill-after");
                            lastCeil.after(afterCeil);
                            j--;
                        }
                    }
                    break;
                }
            } 
        }
    });
}

//表格拆分
function spliteTable($table){
    var trs = $table.find('tr');    //所有行
    var nextTrs = [];
    for (var i = 0; i < trs.length; i++) {
        var $ceil = $(trs[i]);              //一行
        var ceilHeight = $ceil.offset().top + $ceil.height();   //顶部偏移加高度
        if(ceilHeight>pageHeight-50){   //当该行超过单页内容高度时;
            nextTrs.push(trs[i].outerHTML);     //储存单行的元素标签
            $ceil.remove();     //移除当前行
        }
    }
    if(nextTrs.length>0){
        //创建表格
        var $newtable = $('<table style="border-collapse: collapse;border-spacing: 0;border: 1px solid #c0c0c0;" ></table>');
        var $tbody = $('<tbody></tbody>');
        var $thead = $('<thead></thead>');
        $newtable.append($thead);
        $newtable.append($tbody);
        //把储存的行加入新的表格,把新表格插入到原表格后
        for(var i=0; i<nextTrs.length;i++){
            $tbody.append($(nextTrs[i]))
        }
        $table.css("margin-bottom", '100px');
        $table.after($newtable)
    }
}


// 文档解析
function parseWord1(fy) {
    let $plist = $('.page .content').children();
    let plen = 0;
    for(let i = 0; i < $plist.length; i++) {    //遍历所有段落
        let $p = $($plist[i]);
        $p.css("margin-top","0");
        var ceilHeight = $p.offset().top + $p.height();     //该段的顶部偏移加高度
        if($p.height() > (pageHeight - 100)){
            ceilSplit($p);
            $p.remove();
        }
        if($p.attr("class") == "TOC-1"){
            let cates = $p.children();
            cates.each((index,cate) => {
                if(index == cates.length - 1){
                    $(cate).addClass("page-cate-last");
                }else{
                    $(cate).addClass("page-cate");
                }
                $p.before(cate);
            });
            $p.remove();
        }
        plen++;
    }
    if(plen == $plist.length){
        fy();
    }
}

function parseWord() {
    let $plist = $('.page .content').children();
    let pageWidth = $('.page .content').width();
    var page = 1;
    $plist.each(function(index, p) {    //遍历所有段落
        let $p = $(p);
        var ceilHeight = $p.offset().top + $p.height();     //该段的顶部偏移加高度
        if (ceilHeight > (pageHeight * page - 50)) {    //如果高于总页内容高时
            if ($p.height() > 28) {     //且该段高度超过一行
                let text;       //文本内容
                let fontSize;   //字码
                let family;     //字型
                let $childs = $p.contents();    //该段所有子节点              
    
                let totalWidth = 0;     //内容总宽
                let pIndex = 0;         //行数
                let pages = [];
                let $spanLine;
                let $pLine;
                let spans = [];
                let spanNum = -1;
                for(var j = 0; j < $childs.length; j++) {
                    let $child = $childs[j];    //单个子节点
                    let type = $child.nodeType;     //节点类型
                    let $span;   
                    if(type==3) {   //文本
                        text = $child.nodeValue;    //文本值
                        fontSize = parseFloat($p.css("fontSize"));
                        family = parseFloat($p.css("fontFamily"));
                    }else if(type==1){  //元素
                        spanNum++;
                        $span = $($child);  //保存该元素
                        text = $span.text();
                        fontSize = parseFloat($span.css("fontSize"));
                        family = parseFloat($span.css("fontFamily"));
                    }
                    var ruler = $('.ruler').css({   //···隐藏块
                        "font-size": fontSize,
                        "font-family": family
                    });
                    for (var i = 0; i < text.length; i++) {
                        let cell = text.substr(i, 1);
                        ruler.text(cell);
                        totalWidth += ruler.width();
                        let pw = pageWidth;     //编辑页的宽
                        if(totalWidth>=pw){     //当总字数宽度超过总宽  
                            pIndex++;       //行数增加
                            totalWidth = ruler.width();     //
                        }
                        if (!pages[pIndex]) {   
                            $pLine = $('<p></p>');
                            $pLine.attr('style', $p.attr('style'));
                            if (pIndex > 0) {
                                $pLine.css('text-indent', '0')
                            }
                            pages[pIndex] = $pLine;
                        }
                        if(type==1&&!spans[spanNum]) {
                            $spanLine = $('<span></span>');
                            $spanLine.attr('style', $span.attr('style'));
                            $spanLine.attr("onclick",$span.attr("onclick"));    //保留后台返回结果添加的事件属性
                            spans[spanNum] = $spanLine;
                            $pLine.append($spanLine);
                        }
                        if(type==3){
                            $pLine.append(cell);
                        }else if(type==1){
                            $spanLine.append(cell);
                        }
                    }
                }
                
                if (pages.length > 1) {
                    pages.map(item => {
                        $p.before(item)
                    })
                    $p.remove();
                }
            }
            page++;
        }
    })
    updatePage();
}

//页眉
function setPageHeader(content) {
    pageHeader = content;
    $('.h-content').text(pageHeader);
}
//页脚
function setPageFooter(content) {
    pageFooter = content;
    $('.f-content').text(pageFooter);
}
//背景
function setPageBackground(img) {
    pageBackground = img;
    $('.background').attr('src', img).show();
}
//取消背景
function canclePageBackground() {
    pageBackground = '';
    $('.background').hide();
}

//页眉
function getPageHeader(content) {
    return pageHeader;
}
//页脚
function getPageFooter(content) {
    return pageFooter;
}
//获取背景
function getPageBackground() {
    var divHtml = $('.background').prop('outerHTML');
    if (divHtml.length < 1) {
        return ""
    }
    return divHtml;
}
//禁止编辑
function setEditReadOnly(enable) {
    $('.content').attr('contenteditable', enable);
}
//全局点击事件
$(document.body).on('click', function(event) {
//    if (event.target.tagName != 'TD' && currentTable) {
//        $('.edit-table').hide()
//    }
})

var currentRow;
var currentCol;
//插入表格
function insertTable(row, col) {
    var $table = $('<table style="border-collapse: collapse;border-spacing: 0;border: 1px solid #c0c0c0;" data-rows="' + row + '" data-cols="' + col + '"></table>');
    var $tbody = $('<tbody></tbody>');
    var $thead = $('<thead></thead>');
    $table.append($thead);
    $table.append($tbody);
    for (var i = 0; i < row; i++) {
        var $tr = $('<tr></tr>');
        for (var j = 0; j < col; j++) {
            var $td = $('<td style="border: 1px solid #d0d0d0;color: #404060; padding: 10px;width: 120px;word-break: break-all;" data-row="' + i + '" data-col="' + j + '"></td>');
            $tr.append($td)
        }
        $tbody.append($tr);
    }

    var tableHtml = $($table).html();
    SSCommandParams('insertHtml', false, '<table data-rows="' + row + '" data-cols="' + col + '">' + tableHtml + '</table>');
}

function insertHead() {
    var $thead = currentTable.find('thead');
    var col = currentTable.attr('data-cols');
    var $tr = $('<tr></tr>');
    for (var j = 0; j < col; j++) {
        var $th = $('<th style="border: 1px solid #d0d0d0;color: #404060; padding: 10px;width: 120px;background: #f5f5f5;word-break: break-all;" data-col="' + j + '"></th>');
        $tr.append($th)
    }
    $thead.append($tr);
}

function deleteHead() {
    var $thead = currentTable.find('thead');
    $thead.empty();
}
//插入行 flag:before插入目标行前，after插入到目标行后
function insertRow(flag) {
    console.log('行表格=' + currentTable);
    var cols = currentTable.attr('data-cols');
    var $row = currentTable.find('tr').eq(currentRow);

    var $tr = $('<tr></tr>');
    for (var j = 0; j < cols; j++) {
        var $td = $('<td style="border: 1px solid #d0d0d0;color: #404060; padding: 10px;width: 120px;word-break: break-all;" data-row="' + currentRow + '" data-col="' + j + '"></td>');
        $tr.append($td)
    }
    if (flag == 'before') {
        $row.before($tr)
        currentRow++;
    } else {
        $row.after($tr)
    }
    updateTable();
}
//插入列 flag:before插入目标列前，after插入到目标列后
function insertCol(flag) {
    console.log('列表格=' + currentTable);
    var $trs = currentTable.find('tbody tr');
    $trs.each(function() {
        var $ctd = $(this).find('td').eq(currentCol);
        var $td = $('<td style="border: 1px solid #d0d0d0;color: #404060; padding: 10px;width: 120px;word-break: break-all;" data-row="' + currentRow + '" data-col="' + currentCol + '"></td>');
        if (flag == 'before') {
            $ctd.before($td)
        } else {
            $ctd.after($td)
        }
    })
    var $trs = currentTable.find('thead tr');
    $trs.each(function() {
        var $ctd = $(this).find('th').eq(currentCol);
        var $td = $('<th style="border: 1px solid #d0d0d0;color: #404060; padding: 10px;width: 120px;background: #f5f5f5;word-break: break-all;" data-col="' + currentCol + '"></th>');
        if (flag == 'before') {
            $ctd.before($td)
        } else {
            $ctd.after($td)
        }
    })
    if (flag == 'before') {
        currentCol++;
    }
    updateTable();
}

//删除行
function deleteRow() {
    var $row = currentTable.find('tr').eq(currentRow);
    $row.remove();
    updateTable();
}
//删除列
function deleteCol() {
    var $trs = currentTable.find('tr');
    $trs.each(function() {
        var $ctd = $(this).find('td,th').eq(currentCol);
        $ctd.remove();
    })
    updateTable();
}
//更新表格
function updateTable() {
    var $trs = currentTable.find('tr');
    var $tds;
    $trs.each(function(i, tr) {
        $tds = $(tr).find('td');
        $tds.each(function(j, td) {
            $(td).attr('data-row', i);
            $(td).attr('data-col', j);
        })
    })
    currentTable.attr('data-rows', $trs.length);
    currentTable.attr('data-cols', $tds.length);
}





function enableScoller(canScoller) {
    if (canScoller) {
        document.addEventListener("touchmove", function(event) {
            event.preventDefault() //不产生作用
        }, {
            passive: true
        });
    } else {
        document.body.addEventListener('touchmove', function(e) {
            e.preventDefault();
        }, {
            passive: false
        });
    }
}
var replaceParentNode;
var _aukeyWord;
var _auRightWord;

function AuxWriting(keyword, rightword, tipWord) {
    // let editFrame = $('.page').get(0).contentWindow;
    // let $warp = editFrame.document.body;
    _aukeyWord = keyword;
    _auRightWord = rightword;
    let $warp = $('.content').get(0);
    let content = $warp.innerHTML;
    let reg = new RegExp(keyword, "g");
    let regRight = new RegExp('<span class="tag-item">' + keyword + '</span>', 'g');
    let showReg = '<span class="tag-item" style="color: red;text-decoration: underline;text-decoration-style:solid;cursor: pointer">' + keyword + '</span>';
    content = content.replace(reg, showReg);
    $warp.innerHTML = content;
    // let $taglist = editFrame.document.getElementsByClassName('tag-item');
    let $taglist = document.getElementsByClassName('tag-item');
    for (let index in $taglist) {
        $taglist[index].onclick = function() {
            let $parent = this.parentNode;
            let _c = $parent.innerHTML;

            let html = _c.replace(showReg, rightword);
            console.log(html);
            replaceParentNode = $parent;
            let dict = {
                action: 'replace',
                data: {
                    'html': html,
                    "tipWord": tipWord
                }
            };
            var jsonstr = JSON.stringify(dict);
            if(window.android){
                window.android.postMessage(jsonstr);
            }else if(window.webkit){
                window.webkit.messageHandlers.sendMessage.postMessage(jsonstr);
            }
//            replaceHtml(html);
//            window.webkit.messageHandlers.showWritingAlert.postMessage(dict);
        }
    }
}

function getEditorScrollHeight() {
    let editFrame = $('.page').get(0).contentWindow;
    let edBody = editFrame.document.body;
    return edBody.scrollHeight;
}
var _keyWord;
var _textContent;
var lawList = [];
function findActivityWord(keyword, textContent, index) {
    if(index=='0'){
        lawList = [];
    }
    lawList.push({
        "keyword": keyword,
        "content": textContent
    })
    _keyWord = keyword;
    _textContent = textContent;
    let $warp = $('.content').get(0);
    let content = $warp.innerHTML;
    let reg = new RegExp(keyword, "g");
    let showReg = '<span class="activity-item" data-index="'+index+'" style="color: blue;text-decoration: underline;text-decoration-style:solid;cursor: pointer">' + keyword + '</span>';

    content = content.replace(reg, showReg);
    $warp.innerHTML = content;
}

function clickActivityWord() {
    $('.activity-item').unbind('click');
    $('.activity-item').click(function(){
        var index = $(this).data('index');
        var law = lawList[index];
        let dict = {
            action: 'insert',
            data: law
        };
        var jsonstr = JSON.stringify(dict);
        if(window.android){
            window.android.postMessage(jsonstr);
        }else if(window.webkit){
            window.webkit.messageHandlers.sendMessage.postMessage(jsonstr);
        }
    })
}

function replaceHtml(html) {
    replaceParentNode.innerHTML = html;
}

function insertDrawToEditor() {
    let drawLine = $('#darw-line');
    return drawLine.innerHTML;
}


var pageHeight = 878;
var pageHeader = '';
var pageFooter = '';
var pageBackground = '';
$('.page .content').wysiwygEvt();