class Pager{

    constructor(){
        this.pageNum = 6;    //显示页数
        this.total = 0;     //总页
        this.midNum = 0;     //中页
        this.firstPage = 0;  //左边剩余页数
        this.lastPage = 0;   //右边剩余页数
        this.moveStep = 0;   //移动页数
        this.selected = 0;
    }

    //初始化
    init(pageNum,total){
        this.pageNum = pageNum ? pageNum : this.pageNum;
        this.total = total;
        this.midNum = parseInt(this.pageNum / 2) + 1;
        if(this.total >= this.pageNum){
            this.lastPage = this.total - this.pageNum;
        }
    }

    //上一页
    prev(){
        let cur = parseInt($(".pager-num.pager-active").index(".pager-num"));
        cur - 1 < 0 ? cur = 0 : cur -= 1;
        $(".pager-num").eq(cur).click();
    }

    //下一页
    next(){
        let cur = parseInt($(".pager-num.pager-active").index(".pager-num"));
        cur += 1;
        $(".pager-num").eq(cur).click();
    }

    //跳转到某页
    go(cur){
        this.selected = cur;
        //判断下一页是否可用
        this.selected === this.total ?
        $(".pager-next").addClass("pager-next-unable") : $(".pager-next").removeClass("pager-next-unable");
        //判断上一页是否可用
        this.selected === 1 ?
        $(".pager-prev").addClass("pager-prev-unable") : $(".pager-prev").removeClass("pager-prev-unable");
        if(this.total > this.pageNum){
            
            if(cur == this.midNum) return;

            if(cur > this.midNum){  //大于中页时
                this.moveStep = cur - this.midNum;
                if(this.moveStep <= this.lastPage){     //可向右切换页
                    this.midNum = cur;
                    this.lastPage -= this.moveStep;     //算尾页后剩下的
                    this.firstPage += this.moveStep;    //算首页前剩下的
                    $(".pager-num").each((i,item)=>{
                        let $item = $(item);
                        let text = parseInt($item.text()) + this.moveStep;
                        if($item.attr("class").indexOf("pager-mid") != -1){
                            $item.addClass("pager-active").parent().siblings().find(".pager-num").removeClass("pager-active");
                            $item.text(cur);
                        }else{
                            $item.text(text);
                        }
                    });
                }else{
                    if(this.lastPage > 0){
                        this.midNum += this.lastPage;
                        this.firstPage += this.lastPage;
                        $(".pager-num").each((i,item)=>{
                            let $item = $(item);
                            let text = parseInt($item.text()) + this.lastPage;
                            $item.text(text);
                            if($item.text() == cur){
                                $item.addClass("pager-active").parent().siblings().find(".pager-num").removeClass("pager-active");
                            }
                        });
                        this.lastPage = 0;
                    }
                }
            }

            if(cur < this.midNum){  //小于中页时
                this.moveStep = this.midNum - cur;
                if(this.moveStep < this.firstPage){     //可向左切换页
                    this.midNum = cur;
                    this.lastPage += this.moveStep;
                    this.firstPage -= this.moveStep;
                    $(".pager-num").each((i,item)=>{
                        let $item = $(item);
                        let text = parseInt($item.text()) - this.moveStep;
                        if($item.attr("class").indexOf("pager-mid") != -1){
                            $item.addClass("pager-active").parent().siblings().find(".pager-num").removeClass("pager-active");
                            $item.text(cur);
                        }else{
                            $item.text(text);
                        }
                    });
                }else{
                    if(this.firstPage > 0){
                        this.midNum = parseInt(this.pageNum / 2) + 1;
                        this.lastPage += this.firstPage;
                        $(".pager-num").each((i,item)=>{
                            let $item = $(item);
                            let text = parseInt($item.text()) - this.firstPage;
                            $item.text(text);
                            if($item.text() == cur){
                                $item.addClass("pager-active").parent().siblings().find(".pager-num").removeClass("pager-active");
                            }
                        });
                        this.firstPage = 0;
                    }
                }
            }
        }
        
        this.lastPage ? $(".pagerlist .seat").parent().show() && $(".pager-last").show() 
        : $(".pagerlist .seat").parent().hide() && $(".pager-last").hide();

    }

}