//可编辑div获取坐标
const getDivPosition = function(element) {
    var caretOffset = 0;
    var doc = element.ownerDocument || element.document;
    var win = doc.defaultView || doc.parentWindow;
    var sel;
    if (typeof win.getSelection != "undefined") { //谷歌、火狐
        sel = win.getSelection();
        if (sel.rangeCount > 0) { //选中的区域
            var range = win.getSelection().getRangeAt(0);
            var preCaretRange = range.cloneRange(); //克隆一个选中区域
            preCaretRange.selectNodeContents(element); //设置选中区域的节点内容为当前节点
            preCaretRange.setEnd(range.endContainer, range.endOffset); //重置选中区域的结束位置
            caretOffset = preCaretRange.toString().length;
        }
    } else if ((sel = doc.selection) && sel.type != "Control") { //IE
        var textRange = sel.createRange();
        var preCaretTextRange = doc.body.createTextRange();
        preCaretTextRange.moveToElementText(element);
        preCaretTextRange.setEndPoint("EndToEnd", textRange);
        caretOffset = preCaretTextRange.text.length;
    }
    return caretOffset;
}

//获取光标前300个字符
function getPositionBeforeText(element) {
    let selecetText = getSelectedText();
    if (selecetText.length > 0) {
        return selecetText;
    }
    let text = $('.content').text();
    let offset = getDivPosition(element);
    if (text.length > 300) {
        text = text.substr(offset - 300, 300);
    } else {
        text = text.substr(0, offset);
    }
    return text;
}

//获取选中文本内容
function getSelectedText() {
    var content = '';
    try {
        if (window.getSelection) {
            content = window.getSelection().toString();
        }

    } catch (err) {

    }
    return content;
}
var selectionRange;
//获取选中的html
function getSelectedHtml(option) {
    var selectedHtml = "";
    var documentFragment = null;
    try {
        selectionRange = window.getSelection().getRangeAt(0);
        if (window.getSelection) {
            documentFragment = window.getSelection().getRangeAt(0).cloneContents();
        } else if (document.selection) {
            documentFragment = document.selection.createRange().HtmlText;
        }
        console.log("position:",documentFragment);
        if (documentFragment.childNodes && documentFragment.childNodes.length) {
            for (var i = 0; i < documentFragment.childNodes.length; i++) {
                var childNode = documentFragment.childNodes[i];

                if (childNode.nodeType == 3) { // Text 节点
                    var parentNode = window.getSelection().baseNode.parentNode;
                    var style = '';
                    if (parentNode.tagName == 'SPAN') {
                        style = parentNode.getAttribute('style');
                        if(!style) {
                            style = parentNode.parentNode.getAttribute('style');
                        }
                        style += ";margin-bottom:0px;";
                    }
                    if (option.fontSize) {
                        if (style.indexOf('font-size') != -1) {
                            style = style.replace(/font-size: [0-9.]+px/ig, 'font-size: ' + option.fontSize);
                        } else {
                            style += 'font-size: ' + option.fontSize + ';';
                        }
                    }
                    if (option.fontColor) {
                        if (style.indexOf('color') != -1) {
                            style = style.replace(/color: [#a-z0-9]+;/ig, 'color: ' + option.fontColor + ';');
                        } else {
                            style += 'color: ' + option.fontColor + ';';
                        }
                    }
                    if (option.fontName) {
                        if (style.indexOf('font-family') != -1) {
                            style = style.replace(/font-family: .+;/ig, 'font-family: ' + option.fontName + ';');
                        } else {
                            style += 'font-family: ' + option.fontName + ';';
                        }
                    }
                    if (option.backgroundColor) {
                        if (style.indexOf('background') != -1) {
                            style = style.replace(/background: [#a-z0-9]+;/ig, 'background: ' + option.backgroundColor + ';');
                        } else {
                            style += 'background: ' + option.backgroundColor + ';';
                        }
                    }
                    if (option.fontWeight) {
                        if (style.indexOf('font-weight') != -1) {
                            style = style.replace(/font-weight: [a-z0-9]+;/ig, 'font-weight: ' + option.fontWeight + ';');
                        } else {
                            style += 'font-weight: ' + option.fontWeight + ';';
                        }
                    }
                    if (option.textIndent) {
                        if (style.indexOf('text-indent') != -1) {
                            style = style.replace(/text-indent: [0-9.]+px/ig, 'text-indent: ' + option.textIndent + ';');
                        } else {
                            style += 'text-indent: ' + option.textIndent + ';';
                        }
                    }
                    if (option.textAlign) {
                        if (style.indexOf('text-align') != -1) {
                            style = style.replace(/text-align: [a-z]+;/ig, 'text-align: ' + option.textAlign + ';');
                        } else {
                            style += 'text-align: ' + option.textAlign + ';';
                        }
                    }
                    if (option.textDecoration) {
                        if (style.indexOf('text-decoration') != -1) {
                            style = style.replace(/text-decoration: [a-z]+;/ig, 'text-decoration: ' + option.textDecoration + ';');
                        } else {
                            style += 'text-decoration: ' + option.textDecoration + ';';
                        }
                    }
                    if (option.fontStyle) {
                        if (style.indexOf('font-style') != -1) {
                            style = style.replace(/font-style: [a-z]+;/ig, 'font-style: ' + option.fontStyle + ';');
                        } else {
                            style += 'font-style: ' + option.fontStyle + ';';
                        }
                    }
                    if (option.lineHeight) {
                        if (style.indexOf('line-height') != -1) {
                            style = style.replace(/line-height: [0-9.]+px/ig, 'line-height: ' + option.lineHeight + ';');
                        } else {
                            style += 'line-height: ' + option.lineHeight + ';';
                        }
                    }
                    if (option.textAlign) {
                        selectedHtml += '<p style="'+style+'">'+childNode.nodeValue+'</p>'
                    }else{
                        selectedHtml += '<span style="'+style+'">'+childNode.nodeValue+'</span>'
                    }
                } else {
                    if (option.fontSize) {
                        childNode.style.fontSize = option.fontSize;
                    }
                    if (option.fontColor) {
                        childNode.style.color = option.fontColor;
                    }
                    if (option.fontName) {
                        childNode.style.fontFamily = option.fontName;
                    }
                    if (option.backgroundColor) {
                        childNode.style.background = option.backgroundColor;
                    }
                    if (option.fontWeight) {
                        childNode.style.fontWeight = option.fontWeight;
                    }
                    if (option.textIndent) {
                        childNode.style.textIndent = option.textIndent;
                    }
                    if (option.textAlign) {
                        childNode.style.textAlign = option.textAlign;
                    }
                    if (option.textDecoration) {
                        childNode.style.textDecoration = option.textDecoration;
                    }
                    if (option.fontStyle) {
                        childNode.style.fontStyle = option.fontStyle;
                    }
                    if (option.lineHeight) {
                        childNode.style.lineHeight = option.lineHeight;
                    }
                    var nodeHtml = childNode.outerHTML;
                    selectedHtml += nodeHtml;
                }
            }
        } else {

        }

    } catch (err) {

    }


    return selectedHtml;
}