let canvas = document.getElementById("drawing-board");
let ctx = canvas.getContext("2d");
// let eraser = document.getElementById("eraser");
// let brush = document.getElementById("brush");
// let reSetCanvas = document.getElementById("clear");
// let aColorBtn = document.getElementsByClassName("color-item");
// let save = document.getElementById("save");
// let undo = document.getElementById("undo");
// let range = document.getElementById("range");
let clear = false;
let activeColor = 'black';
let lWidth = 20;
let historyDeta = [];
let isShow = false;
var lastWidth = 20;
var lastColor;

document.body.style.overflowX = 'hidden'

//setCanvasBg('white');

listenToUser(canvas);

// getColor();
window.onresize = function() {
    //    document.body.style.overflowY = 'auto'

}
window.onbeforeunload = function() {
    return "Reload site?";
};

function autoSetSize(canvas) {

    canvasSetSize();

    function canvasSetSize() {
        let pageWidth = document.documentElement.clientWidth;
        let pageHeight = document.documentElement.scrollHeight;
        canvas.height = pageHeight;
        canvas.width = pageWidth;

    }

    window.onresize = function() {
        canvasSetSize();
    }
}

function setCanvasBg(color) {
    ctx.fillStyle = 'rgba(255, 255, 255, 0)';
    ctx.fillRect(0, 0, canvas.width, canvas.height);
    ctx.fillStyle = 'rgba(255, 255, 255, 0)';
}

function listenToUser(canvas) {
    let painting = false;
    let lastPoint = { x: undefined, y: undefined };
    let lastScrollPoint = { x: undefined, y: undefined };

    if (document.body.ontouchstart !== undefined) {
        canvas.addEventListener("touchstart", function(e) {
            this.firstDot = ctx.getImageData(0, 0, canvas.width, canvas.height); //在这里储存绘图表面
            saveData(this.firstDot);
            painting = true;
            let x = e.touches[0].pageX;
            let y = e.touches[0].pageY;
            lastPoint = { "x": x, "y": y };
            lastScrollPoint = { "x": x, "y": y };
            ctx.save();
            drawCircle(x, y, 0);
        });
        canvas.addEventListener("touchmove", function(e) {

            if (e.touches.length == 2) {
                //移动目标的 X Y 坐标
                let x = e.touches[0].pageX;
                let y = e.touches[0].pageY;
                let newPoint = { "x": x, "y": y };
                //设置当前点击元素的 top left 定位值
                // console.log('滑动x='+x+'y=' + y);
                // console.log('间距=' + (newPoint.y-lastPoint.y));
                var scrollY = newPoint.y-lastPoint.y;
                window.scrollBy(0,-Math.round(scrollY));
                lastScrollPoint = newPoint;
            }else if (painting) {
                let x = e.touches[0].pageX;
                let y = e.touches[0].pageY;
                let newPoint = { "x": x, "y": y };
                drawLine(lastPoint.x, lastPoint.y, newPoint.x, newPoint.y);
                lastPoint = newPoint;
            }

        });

        canvas.addEventListener("touchend", function() {
            painting = false;
        });
    } else {
        canvas.addEventListener("touchstart", function(e) {
            this.firstDot = ctx.getImageData(0, 0, canvas.width, canvas.height); //在这里储存绘图表面
            saveData(this.firstDot);
            painting = true;
            let x = e.touches[0].pageX;
            let y = e.touches[0].pageY;

            lastPoint = { "x": x, "y": y };
            ctx.save();
            drawCircle(x, y, 0);
        });
        canvas.addEventListener("touchmove", function(e) {
            console.log(e);
            if (e.touches.length == 1) {

            //移动目标的 X Y 坐标
            var touchMoveX = e.targetTouches[0].pageX,
            touchMoveY = e.targetTouches[0].pageY;
            //设置当前点击元素的 top left 定位值
            console.log('滑动x='+touchMoveX+'y=' + touchMoveY);

            };
            if (painting) {
                let x = e.touches[0].pageX;
                let y = e.touches[0].pageY;

                let newPoint = { "x": x, "y": y };
                drawLine(lastPoint.x, lastPoint.y, newPoint.x, newPoint.y, clear);
                lastPoint = newPoint;
            }

        });

        canvas.addEventListener("touchend", function() {
            painting = false;
        });

    }
}



function drawCircle(x, y, radius) {
    ctx.save();
    ctx.beginPath();
    ctx.arc(x, y, radius, 0, Math.PI * 2);
    ctx.fill();
    if (clear) {
        ctx.clip();
        ctx.clearRect(0, 0, canvas.width, canvas.height);
        ctx.restore();
    }
}

function drawLine(x1, y1, x2, y2) {
    ctx.lineWidth = lWidth;
    ctx.lineCap = "round";
    ctx.lineJoin = "round";
    if (clear) {
        ctx.save();
        ctx.lineWidth = 20;
        ctx.globalCompositeOperation = "destination-out";
        ctx.moveTo(x1, y1);
        ctx.lineTo(x2, y2);
        ctx.stroke();
        ctx.closePath();
        ctx.clip();
        ctx.clearRect(0, 0, canvas.width, canvas.height);
        ctx.restore();
    } else {
        ctx.lineWidth = lWidth;

        ctx.moveTo(x1, y1);
        ctx.lineTo(x2, y2);
        ctx.stroke();
        ctx.closePath();
    }
}
//如果有画布 添加画布
function appendDraw(img) {

    let pageWidth = document.documentElement.scrollWidth;
    // let pageHeight = 400;
    let saveA = document.createElement("img");
    saveA.onerror = function(){
        console.log("img:error");
        saveA.style.display = "none";
    }
    saveA.setAttribute("name","draw");
    saveA.src = img[0].src;
    saveA.style.position = 'absolute';
    saveA.style.width = '100%';
    saveA.style.top = 0;
    saveA.style.pointerEvents = 'none';
    saveA.id = 'draw-line'
    saveA.style.opacity = '0.85'
    saveA.style.zIndex = "9999";
    saveA.style.backgroundColor = 'rgba(255,255,255,0)';
    document.body.prepend(saveA);
    saveA.onload = function(){

        saveA.style.height = saveA.height;
        
    }
}

function chageLightLine(color) {
    lWidth = 24;
    clear = false;
    ctx.globalAlpha = '\'' + hexToRgba(color, 0.1) + '\'';
    // ctx.opacity = 0.1;
    ctx.fillStyle = hexToRgba(color, 0.1);
    ctx.strokeStyle = hexToRgba(color, 0.1);

}
const hexToRgba = (bgColor, xalpha) => {
    let color = bgColor.slice(1); // 去掉'#'号
    let rgba = [
        parseInt('0x' + color.slice(0, 2)),
        parseInt('0x' + color.slice(2, 4)),
        parseInt('0x' + color.slice(4, 6)),
        xalpha
    ];
    return 'rgba(' + rgba.toString() + ')';
};

function saveImage() {
    var drawLength = $("[name='draw']").length
    if (drawLength > 0) {
        var img = $('body').find("[name='draw']");
        img.remove();
    }
    // let pageHeight = document.documentElement.scrollHeight;
    let imgUrl = canvas.toDataURL("image/png");
    let saveImage = document.createElement("img");
    saveImage.name = 'draw';
    saveImage.style.position = 'absolute';
    saveImage.style.width = '100%';
    saveImage.style.height = 'auto';
    //    saveA.style.overflow = 'hidden';
    saveImage.style.pointerEvents = 'none';
    saveImage.id = 'draw-line'
    saveImage.style.opacity = '0.85'
    saveImage.style.zIndex = "9999";
    saveImage.style.backgroundColor = 'rgba(255,255,255,0)';
    var urlstr = 'url(\' ';
    var laststr = '\') ';
    saveImage.src = imgUrl
        // saveA.style.backgroundImage = urlstr + imgUrl +laststr;
        // saveA.style.backgroundrepeat = "no-repeat";
    document.body.prepend(saveImage);
    hideDraw();
    saveImage.onload = function(){
        saveImage.style.height = saveImage.height;

    }
    

    //    setCanvasBg('white');

}

function setLineColor(color) {
    clear = false;
    lastColor = color;
    ctx.fillStyle = color;
    ctx.strokeStyle = color;
    if (lastWidth) {
        lWidth = lastWidth;
    }
}

function setLineWidth(width) {
    clear = false;
    lWidth = width;
    lastWidth = width;
    if (lastColor) {
        ctx.fillStyle = lastColor;
        ctx.strokeStyle = lastColor;
    }

}

function clearAll() {
    clear = false;
    ctx.clearRect(0, 0, canvas.width, canvas.height);
    setCanvasBg('white');
}

function clickEaser() {
    if (!clear) {
        clear = true;
        // this.classList.add("active");
        // brush.classList.remove("active");
    } else {
        clear = false;
        // this.classList.add("active");
        // eraser.classList.remove("active");
    }
}

function setUnDo() {
    clear = false;
    if (isDrawUndoEnable()){
        ctx.putImageData(historyDeta[historyDeta.length - 1], 0, 0);
        historyDeta.pop()
    }
    //更新状态
    drawStateChange();
}

function isDrawUndoEnable(){
    if (historyDeta.length < 1) {
        return false;
    } else {
        return true;
    }
}

function showDraw() {
    let pageWidth = document.documentElement.scrollWidth;
    let pageHeight = document.documentElement.scrollHeight;

    //如果有画布 ，先把画布画上
    var drawLength = $("[name='draw']").length
    if (drawLength > 0) {
        var img = $('body').find("[name='draw']");
        console.log('有背景画布');
        putImageToCanvas(img[0].src, pageWidth, pageHeight);
    }

    let drawLine = $('#draw-line')[0];
    if (drawLine) {
        drawLine.remove()
    }
    let imgUrl = canvas.toDataURL("image/png");
    // var canvas = document.getElementById("drawing-board");
    putImageToCanvas(imgUrl, pageWidth, pageHeight);
    canvas.addEventListener('touchmove', function(e) {
        e.preventDefault();
    }, false);
    canvas.style.display = 'block';
    //更新状态
    drawStateChange();
}


function getDrawStr() {
    var divHtml = $('#draw-line').prop('outerHTML');
    if (divHtml.length < 1) {
        return ""
    }
    return divHtml;
}

function putImageToCanvas(imgUrl, width, height) {
    var image = new Image()
    image.src = imgUrl
    image.onload = function() {
        ctx.drawImage(image, 0, 0, image.width, image.height);
    }
    var imgData = ctx.getImageData(0, 0, canvas.width, canvas.height);
    canvas.width = width;
    canvas.height = height;
    ctx.putImageData(imgData, 0, 0);
}

function hideDraw() {
    canvas.style.display = 'none'
    //更新状态
    drawStateChange();
}

function eco_refresh() {
    var _body = window.parent;
    var _iframe1 = _body.document.getElementById('ueditor_0');
    window.onbeforeunload = function() {};
    _iframe1.contentWindow.location.reload(true);
}

function getColor() {
    for (let i = 0; i < aColorBtn.length; i++) {
        aColorBtn[i].onclick = function() {
            for (let i = 0; i < aColorBtn.length; i++) {
                aColorBtn[i].classList.remove("active");
                this.classList.add("active");
                activeColor = this.style.backgroundColor;
                ctx.fillStyle = activeColor;
                ctx.strokeStyle = activeColor;
            }
        }
    }
}

function beginAutoSetSize() {
    autoSetSize(canvas)
}
$(document).ready(function() {
    autoSetSize(canvas);
    //    appendDraw();
    console.log('加载完毕')
});

function saveData(data) {
    (historyDeta.length === 10) && (historyDeta.shift()); // 上限为储存10步，太多了怕挂掉
    historyDeta.push(data);
    //更新状态
    drawStateChange();
}

function drawStateChange(){
    var dict = {
        action: 'drawing',
        data: {
            'display' : canvas.style.display,
            'undo' : isDrawUndoEnable()
        }
    };
    window.android.postMessage(JSON.stringify(dict));
}

//过滤font-family
function removeFontFamilys(content) {
    //remove repeat
    var unique = function(arr) {
            var result = [],
                hash = {};
            for (var i = 0, elem;
                (elem = arr[i]) != null; i++) {
                if (!hash[elem]) {
                    result.push(elem);
                    hash[elem] = true;
                }
            }
            return result;
        }
        //
    var arr = content.match(/(font-family:[^><;"]*(;)?)/ig);
    if (!arr) {
        return content;
    }
    arr = unique(arr);
    for (var i = 0; i < arr.length; i++) {
        var reg = new RegExp(arr[i], "ig");
        content = content.replace(reg, "");
    }

    return content;
}